#!/bin/sh

if [ "$(id -u)" != "0" -a -z "$1" ]
then
  exec /sbin/start-stop-daemon -S -c root:root -x "$0" -- $*
  exit 1
fi

MYFILE=`basename $0`
MYPATH=`echo $0 | sed -e 's/'$MYFILE'//g'`
MYPATH=`cd $MYPATH ; pwd`
IMG=/mmc/mmca1/local/share/showq/bluez.png
NOTEPAD=/usr/SYSqtapp/notepad/notepad
STOP='start-stop-daemon --oknodo --stop --quiet --exec'
PAND=/mmc/mmca1/local/bin/pand
FAKEDSM=/mmc/mmca1/local/sbin/fakedsm
DNSPROXY=/usr/bin/dnsproxy
ROUTE=/mmc/mmca1/local/sbin/route

. /home/native/.profile
cd $MYPATH
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/mmc/mmca1/local/lib

if [ ! -f /mmc/mmca1/local/sbin/hcid ]
then
	if [ ! -f ezxbluez-a1200.tar.gz ]
	then
		./showq -u -1 "" -g "$MYPATH/bluez_sm.png" -m "File ezxbluez-a1200.tar.gz don't exists, aborting..."
		exit 1
	fi
	mmsg=`./showq -1 "Install" -2 "Exit" -g "$MYPATH/bluez_sm.png" -m "Install BlueZ binaries?"`
	if [ "$mmsg" = "0" ]
	then
		./showq -u -1 "" -g "$MYPATH/bluez_sm.png" -m "Installing ezxbluez-a1200.tar.gz..." &
		tar xzf "$MYPATH/ezxbluez-a1200.tar.gz" -C /
		rm -rf "$MYPATH/ezxbluez-a1200.tar.gz"
		/bin/kill `pidof showq`
		./showq -t 2 -1 "" -g "$IMG" -m "BlueZ binaries installed, run BlueZ again."
		exit 0
	else
		exit 0
	fi
fi

if [ "`pidof hcid`" = "" ]
then
	mmsg=`./showq -1 "Config" -2 "Start" -3 "Exit" -g "$IMG" -m "BlueZ - choice option"`
	if [ "$mmsg" = "0" ]
	then
		$NOTEPAD -d /mmc/mmca1/local/etc/bluetooth/general.conf
		exit 0
	fi
	if [ "$mmsg" = "1" ]
	then
		./showq -u -1 "" -g "$IMG" -m "Starting BlueZ..." &
		/mmc/mmca1/local/etc/init.d/bluetooth start
		/bin/kill `pidof showq`
		./showq -t 2 -1 "" -g "$IMG" -m "BlueZ started."
		exit 0
	fi
	if [ "$mmsg" = "2" ]
	then
		exit 0
	fi
else
	mmsg=`./showq -1 "PAND" -2 "Stop" -3 "Exit" -g "$IMG" -m "Choice option"`
	if [ "$mmsg" = "0" ]
	then
		if [ "`$PAND -l`" = "" ]
		then
			mmsg=`./showq -1 "Connect" -2 "Cancel" -g "$IMG" -m "Connect with PAND in neighborhood device?"`
			if [ "$mmsg" = "0" ]
			then
				./showq -u -1 "" -g "$IMG" -m "Connecting with PAND..." &
				$PAND --search -n
				/bin/kill `pidof showq`
			fi
			exit 0
		else
			mmsg=`./showq -1 "Disconnect" -2 "Cancel" -g "$IMG" -m "Disconnect PAND?"`
			if [ "$mmsg" = "0" ]
			then
				./showq -u -1 "" -g "$IMG" -m "Disconnecting with PAND..." &
				$PAND --killall
				$STOP $DNSPROXY
				$STOP $FAKEDSM
				$ROUTE del default
				/bin/kill `pidof showq`
				./showq -t 2 -1 "" -g "$IMG" -m "PAND disconnected."
			fi
			exit 0
		fi
	fi
	if [ "$mmsg" = "1" ]
	then
		./showq -u -1 "" -g "$IMG" -m "Stopping BlueZ..." &
		/mmc/mmca1/local/etc/init.d/bluetooth stop
		$STOP $DNSPROXY
		$STOP $FAKEDSM
		$ROUTE del default
		/bin/kill `pidof showq`
		./showq -t 2 -1 "" -g "$IMG" -m "BlueZ stopped."
		exit 0
	fi
	if [ "$mmsg" = "2" ]
	then
		exit 0
	fi
fi
